<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4">

  <app-breadcrumbs [forceReload]="tenantId"></app-breadcrumbs>

  <div
    id="deskListLabel"
    class="h3"
    [innerText]="messages.LIST_TITLE">
  </div>

  <!-- Header -->

  <div class="mt-3 mb-2 d-flex align-items-start">

    <button
      *ngIf="!asFunctionalAdmin"
      ls-button
      class="me-2"
      [icon]="commonIcons.CREATE_ICON"
      [text]="messages.CREATE_DESK_BUTTON_TITLE"
      (click)="openModalWithComponent()">
    </button>

    <button
      type="button"
      class="btn btn-outline-primary me-2"
      [ngbTooltip]="commonMessages.FOLD_ALL"
      (click)="onCollapseButtonClicked(true)">
      <fa-icon [icon]="compressIcon"></fa-icon>
    </button>

    <button
      type="button"
      class="btn btn-outline-primary me-2"
      [ngbTooltip]="commonMessages.EXPAND_ALL"
      (click)="onCollapseButtonClicked(false)">
      <fa-icon [icon]="expandIcon"></fa-icon>
    </button>

    <app-search-bar
      id="title-search"
      class="long-search-input"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="commonMessages.SEARCH_DESK_ADMIN">
    </app-search-bar>


    <span class="flex-grow-1"></span>
    <span class="p-1 px-2" [innerText]="commonMessages.PAGINATION_SIZE_LABEL"></span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="requestDesks(true)">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="deskListLabel"
    class="bg-white table table-striped table-fixed table-borderless border shadow-sm w-100">
    <thead class="border">
      <tr>
        <th scope="col">
          <span
            class="sortable-row"
            [innerText]="commonMessages.NAME">
          </span>
        </th>
        <th
          *ngIf="userPreferences.showAdminIds"
          class="col-id-fixed-size"
          [innerText]="commonMessages.ID">
        </th>
        <th
          scope="col"
          class="col-buttons-fixed-size"
          [innerText]="commonMessages.ACTIONS">
        </th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let desk of deskList">
        <td class="overflow-hidden text-overflow-ellipsis" (click)="onCaretClicked(desk)">
          <span
            *ngFor="let _ of desk.level|times"
            class="sub-desk-padding">
          </span>
          <fa-icon
            [ngClass]="{'invisible' : (desk.directChildrenCount <= 0)}"
            [ngbTooltip]="(collapseAll !== reversedIds.has(desk.id)) ? commonMessages.EXPAND : commonMessages.FOLD"
            [icon]="(collapseAll !== reversedIds.has(desk.id)) ? caretRightIcon : caretDownIcon"
            [fixedWidth]="true"></fa-icon>
          {{ desk.name | namePipe }}
        </td>
        <td *ngIf="userPreferences.showAdminIds">
          <span class="font-monospace text-size-small">{{ desk.id | namePipe }}</span>
        </td>
        <td>
          <button
            type="button"
            class="btn btn-sm btn-outline-primary"
            [title]="commonMessages.EDIT"
            (click)="openModalWithComponent(desk)">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>
          <button
            *ngIf="!asFunctionalAdmin"
            type="button"
            class="btn btn-sm btn-outline-danger ms-2"
            [title]="commonMessages.DELETE"
            (click)="onDeleteButtonClicked(desk)"
            [disabled]="desk.directChildrenCount !== 0">
            <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="deskList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_DESK_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="deskTotal"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="deskPage"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="requestDesks(false)">
  </ngb-pagination>

</div>
